from torch import nn

def activation(state, event):
    softplus = nn.Softplus(beta=state["beta"],threshold=state["threshold"])
    return softplus


def init_conv(state,event,m):
    nn.init.kaiming_normal_(m.weight, mode='fan_out')


def register(mf):
    mf.register_event('activation_layer_cls', lambda:nn.Softplus, unique=True)
    mf.register_event('activation_layer', activation, unique=True)
    mf.register_event('init_conv', init_conv, unique=True)
    mf.register_defaults({
        "beta": 1,
        "threshold":20,
    })
